include<ub.scad>; //⇒ v.gd/ubaer or https://github.com/UBaer21/UB.scad
/*[Hidden]*/
designVersion=1.4;
useVersion=22.046;//(sites.google.com/site/ulrichbaer)
assert(Version>=useVersion,str("lib version ",Version," detected, install ",useVersion," ub.scad library‼ ⇒http://v.gd/ubaer"));
/*[Basics]*/
nozzle=.2;
bed=false;
pPos=[0,0];
info=false;
name=undef;

/*[Trip-Ring]*/

fingerCircumference=57;
rand=.8;
breit=3.5;
engrave=true;
rTXT1="Omnia";
rTXT2="Vincit";
rTXT3="Amor";
font="CapitalisTypOasis:style=Regular";//["CapitalisTypOasis:style=Regular","Arial:style=Regular","Bahnschrift:style=Regular","arabella"]
tSpread0=1.4;
tSpread=1.4;

id=runden(fingerCircumference/PI,2);
echo(str("\tRing size (DE)=",fingerCircumference,"mm, finger diameter=",id,"mm\n"));
idRing=norm([id,breit])+rand+spiel*2;

T(printPos){
  
Tz(breit/2*cos(20)+sin(20)*(idRing/2+rand))Polar(3,rand*.5+id/6)R(20)TripRing(tID=$idx);
//%cylinder(20,d=id,center=true);
}


module TripRing(id=idRing,rand=rand,breit=breit,tID=0,tSpread=tSpread){
od=id+rand*2;
txt=[rTXT1,rTXT2,rTXT3][tID];
tSize=breit*0.6;
difference(){
  RotEx(fn=100)
  Rund(.25)
  T(id/2+rand/2) Superellipse(r=rand/2,r2=breit/2,n=5,n2=2,fn=72);
  
if(engrave) for(i=[1:len(txt)])rotate(-gradS(tSize*(i==1?tSpread0:tSpread),r=id/2)*i +gradS(tSize*tSpread,r=id/2)*(len(txt)/2+.5)+180)T(id/2-1)R(90,0,90)Roof(fn=0)offset(.1)mirror([1,0])text(txt[i-1],size=tSize,valign="center",halign="center",font=font);
}
}

// Roof
//!Roof(opt=1,h=2,base=-4,floor=true,deg=75,center=true)difference(){square(5);circle(3);}

module Roof(base=1.05,deg=35,opt=1,floor=false,center=false,h,fn=fn,name=false){
s=tan(deg);
linear_extrude(base,center=center,convexity=5)children();
Tz(center?base/2:base)intersection(){
  scale([1,1,s])roof(method=opt?"voronoi":"straight",$fn=fn,convexity=5)children(); // experimental feature comment out if not activated in preferences
  if(h)cube([viewportSize*4,viewportSize*4,h*2],true);
  }
  if(floor)Tz(center?-base/2:0)intersection(){
  scale([1,1,-s])roof(method=opt?"voronoi":"straight",$fn=fn,convexity=5)children(); // experimental feature comment out if not activated in preferences
  if(h)cube([viewportSize*4,viewportSize*4,h*2],true);
  }
  
InfoTxt("Roof",["h",h,"deg",str(deg,"° (",s,")")],name);
}